PRO IRIS_L12calc, files, Nfiles, dest

  ;get number of rasters, and their start and end file
  ; a raster ends if the sign of dpztx changes
  startraster=[0]
  for filenr=0,Nfiles-1 do begin
    fxread, files[filenr], data, header, /nodata
    pztx = fxpar(header, 'PZTX')
    
    if filenr gt 0 then begin
      dpztx = pztx - pztxold
      if dpztx ne 0 then dpztx=dpztx/abs(dpztx)
      if dpztxold ne 9 then begin ;if this is not the second take of a raster
        if dpztx ne dpztxold then begin ;raster ends, start a new one
          if N_ELEMENTS(startraster) eq 1 then endraster = filenr-1 $
          else endraster = [endraster, filenr-1]
          startraster = [startraster, filenr]
          dpztxold = 9
        endif
      endif else dpztxold=dpztx
    endif else begin
      dpztxold = 9
    endelse
    pztxold = pztx
  endfor ;files
  endraster = [endraster, filenr-1]
  
  print, 'found', N_ELEMENTS(startraster), ' rasters'
  print, 'starts ', startraster
  print, 'ends   ', endraster
  
  void = {rastreg, OBSid:'', FDBid:'', CRSid:'', $
    startrow:0L, numrows:0L, startcol:0L, numcols:0L, $
    data:ptr_new()}
    
  for raster=0,N_ELEMENTS(startraster)-1 do begin
    numsteps = endraster[raster] - startraster[raster] + 1
    ;for i=0,numregions-1 do rasterdata[i] = ptr_new(fltarr(numrows[i], numcols[i], numsteps))
    auxdata = fltarr(numsteps, 3)
    
    for filenr=0,numsteps-1 do begin
      fxread, files[filenr+startraster[raster]], data, header
      auxdata[filenr,0] = fxpar(header, 'TIME')
      auxdata[filenr,1] = fxpar(header, 'PZTX')
      auxdata[filenr,2] = fxpar(header, 'PZTY')
      
      OBSid = fxpar(header, 'OBSID')
      FDBid = fxpar(header, 'FDBID')
      CRSid = fxpar(header, 'CRSID')
      
      numregions = fxpar(header, 'REGTOT')
      startrow = fxpar(header, 'ROWSTAR*')
      numrows = fxpar(header, 'ROWNUM*')
      startcol = fxpar(header, 'COLSTAR*')
      numcols = fxpar(header, 'COLNUM*')
      
      sumspec = fxpar(header, 'SUMSPEC')
      sumspat = fxpar(header, 'SUMSPAT')
      
      
      if filenr eq 0 then begin
        regdata = void
        regdata.OBSid = OBSid
        regdata.FDBid = FDBid
        regdata.CRSid = CRSid
        regdata = REPLICATE(regdata, numregions)
      endif
      
      ind = where(regdata.CRSid eq CRSid, count)
      if (count gt 0) && (count ne numregions) then begin
        print, 'strange...'
      endif else if count eq 0 then begin
        regdata2 = void
        regdata2.OBSid = OBSid
        regdata2.FDBid = FDBid
        regdata2.CRSid = CRSid
        regdata2 = REPLICATE(regdata2, numregions)
        regdata = [regdata, regdata2]
        ind = where(regdata.CRSid eq CRSid, count)
      endif
    ;for region=0,numregions-1 do $
    ;  (*rasterdata[region])[*,*,filenr] = data[startrow[region]:startrow[region]+numrows[region]-1, startcol[region]:startcol[region]+numcols[region]-1]
      
    endfor ;filenr
  endfor ;raster
END
